﻿using System;
using System.Collections.Generic;

namespace ProtectionProxy
{
    class ProtectionPicture:IView
    {
        Picture picture = null;
        string user = string.Empty;
        List<string> available_users = new List<string>();
        public ProtectionPicture(string name,string owner)
        {
            picture = new Picture(name,owner);
        }
        #region IView 멤버

        public void View()
        {
            if(IsAvailableUser(user))
            {
                picture.View();
            }
            else
            {
                Console.WriteLine("사진을 볼 수 있는 권한이 없습니다.");
            }
        }

        public string Owner
        {
            get { return picture.Owner; }
        }

        #endregion
        private bool IsAvailableUser(string user)
        {
            if(picture.Owner == user)
            {
                return true;
            }
            foreach(string name in available_users)
            {
                if(name == user)
                {
                    return true;
                }
            }
            return false;
        }
        
        public void AddAvailableUser(string owner,string user)
        {
            if(owner != Owner)
            {
                Console.WriteLine("소유자만이 사용 권한 설정을 할 수 있습니다.");
                return;
            }
            if(IsAvailableUser(user)==false)
            {
                available_users.Add(user);
            }
        }
        
        public void SetUser(string user)
        {
            this.user = user;
        }
    }
}
